#ifndef HOP_H
#define HOP_H

int hop_calc_loc_IP(Graph *g, Vertex *client, Vertex *server);

void hop_calc_sp(Graph *g, Vertex *sender, Vertex **recvr_array, int n,
		char *hop_outfile);

void hop_calc_tapestry(Graph *g, Vertex *sender, Vertex **recvr_array, int n,
                char *hop_outfile, int TAPESTRY_NODEID_SIZE,
                int TAPESTRY_DIGIT_SIZE, int TAPESTRY_NAMESPACE_BASE);

void hop_read(long *hop_array, int n, char *hop_outfile);

void rdp_calc(long *hop_array1, long *hop_array2, int n, char *rdp_outfile);

void hop_calc_sp_maxconn(Graph *g, Vertex *sender, Vertex **recvr_array,
        Graph *new_graph, Vertex *new_sender, Vertex **new_recvr_array,
        int n, char *hop_outfile);

void hop_calc_tapestry_maxconn(Graph *new_graph, Vertex *new_sender,
                Vertex **new_recvr_array, int n,
                char *hop_outfile, int TAPESTRY_NODEID_SIZE,
                int TAPESTRY_DIGIT_SIZE, int TAPESTRY_NAMESPACE_BASE);

void hop_read_maxconn(long *nbr_array, int n, char *hop_outfile);

void hop_calc_sp_partition(Graph *g, Vertex **recvr_array,
                int n, char *hop_outfile);

void hop_calc_tapestry_partition(Graph *g, Vertex **recvr_array,
                int n, char *hop_outfile,
                int TAPESTRY_NODEID_SIZE, int TAPESTRY_DIGIT_SIZE,
                int TAPESTRY_NAMESPACE_BASE);

void hop_calc_tapestry_protocol(Graph *new_graph, Vertex *new_sender,
                Vertex **new_recvr_array, int n,
                char *hop_outfile, int TAPESTRY_NODEID_SIZE,
                int TAPESTRY_DIGIT_SIZE, int TAPESTRY_NAMESPACE_BASE);
#endif
