#ifndef READ_H
#define READ_H

void read_stress(char *topology_fn, char *out_dir,
                int TAPESTRY_DIGIT_SIZE, int TAPESTRY_NODEID_SIZE,
                int TAPESTRY_NAMESPACE_SIZE, int group_size,
                float *stress_unicast_array, float *stress_tapestry_array,
		float *stress_ratio_array);
void read_delay(char *topology_fn, char *out_dir,
                int TAPESTRY_DIGIT_SIZE, int TAPESTRY_NODEID_SIZE,
                int TAPESTRY_NAMESPACE_SIZE, int group_size,
                float *rdp_array);

void exp12_read_stress(char *topology_fn, char *out_dir,
                int TAPESTRY_DIGIT_SIZE, int TAPESTRY_NODEID_SIZE,
                int TAPESTRY_NAMESPACE_SIZE, int group_size, int num_clusters,
                float *stress_unicast_array, float *stress_tapestry_array,
                float *stress_ratio_array);
void exp12_read_delay(char *topology_fn, char *out_dir,
                int TAPESTRY_DIGIT_SIZE, int TAPESTRY_NODEID_SIZE,
                int TAPESTRY_NAMESPACE_SIZE, int group_size, int num_clusters,
                float *rdp_array);

void exp13_14_read_delay(char *topology_fn, char *out_dir,
                int TAPESTRY_DIGIT_SIZE, int TAPESTRY_NODEID_SIZE,
                int TAPESTRY_NAMESPACE_SIZE, int group_size, int percentage,
                float *perAD_array, float *perAE_array,
                float *perBD_array, float *perBE_array,
                float *perC_array);

void exp15_read_delay(char *topology_fn, char *out_dir,
                int TAPESTRY_DIGIT_SIZE, int TAPESTRY_NODEID_SIZE,
                int TAPESTRY_NAMESPACE_SIZE, int group_size, int num_roots,
                float *ratio_array1, float *ratio_array2);
void exp15_read_root(char *topology_fn, char *out_dir,
                int TAPESTRY_DIGIT_SIZE, int TAPESTRY_NODEID_SIZE,
                int TAPESTRY_NAMESPACE_SIZE,
                int group_size, int num_roots, float *join_req_dev_array);
#endif
