#ifndef PICK_H
#define PICK_H

void clear_picked_m_field(Graph *g);
void clear_load_fields(Graph *g);
int find_max_load_mip(Graph *g);
int find_max_load_tap(Graph *g);
void mark_load_field_mip(Graph *g, Vertex *from, Vertex *to);
void mark_load_field_tap(Graph *g, Vertex *from, Vertex *to);
Vertex *pick_1(Graph *g);
Vertex *pick_0(Graph *g);
void pick_n(Graph *g, Vertex **vertex_array, int n);

#endif
