#ifndef GRAPH_H
#define GRAPH_H

#define picked_t l.I    // whether or not this vertex is picked already as
                        // a tapestry node
#define picked_m m.I    // whether or not this vertex is picked already as
                        // a multicast group member
#define rtable n.I      // address of routing table of this tapestry node
#define nodeid o.S      // tapestry node ID

#define locptr p.I	// 32-bit mask of location pointers to 32 objects
#define mroot q.V	// multicast root of this member

#define pnbr r.I	// whether or not this node is on the primary path
			// from the sender to a multicast group member

#define stress c.I      // stress of physical link
#define lstate d.I	// loss state (no loss or loss) of physical link

void print_all_arcs(Graph *g);
int reset_arc_len(Graph *g);

#endif
