#ifndef EXP_H
#define EXP_H

#define MAX_NUM_EXPERIMENT 10
#define MAX_LINE_LEN 256
#define MAX_FILENAME_LEN 128
#define MAX_NUM_NBRS 3

void init_output_file_names(char *topology_fn, char *out_dir,
        char *hop_outfile1, char *hop_outfile2,
        char *rdp_outfile, char *stress_outfile1, char *stress_outfile2,
        int TAPESTRY_NODEID_SIZE, int TAPESTRY_DIGIT_SIZE,
        int TAPESTRY_NAMESPACE_BASE, int TAPESTRY_NAMESPACE_SIZE,
        int group_size, int vnn);
Graph *exp_init(char *topology_fn, int TAPESTRY_NODEID_SIZE,
                int TAPESTRY_NAMESPACE_BASE, int TAPESTRY_NAMESPACE_SIZE);
void exp_run(Graph *g, char *topology_fn, char *out_dir,
                int TAPESTRY_NODEID_SIZE, int TAPESTRY_DIGIT_SIZE,
                int TAPESTRY_NAMESPACE_BASE, int TAPESTRY_NAMESPACE_SIZE,
                int group_size, int vnn);

#endif
