#ifndef HOP_H
#define HOP_H

int hop_calc_loc_IP_print(Graph *g, Vertex *client, Vertex *server);
int hop_calc_loc_IP(Graph *g, Vertex *client, Vertex *server);
void hop_calc_loc_planes(Graph *g, Vertex *client, Vertex **roots, 
                         Vertex *server, int TAPESTRY_NODEID_SIZE,
                         int TAPESTRY_DIGIT_SIZE, int TAPESTRY_NAMESPACE_BASE,
                         int PLANES);
void hop_calc_archival(Graph *g, Vertex *client, Vertex *root, 
		       Vertex **servers, int TAPESTRY_NODEID_SIZE,
		       int TAPESTRY_DIGIT_SIZE, int TAPESTRY_NAMESPACE_BASE,
		       int OBJECTS, int THRESHOLD, int REQUESTS,
		       int * serverload, float frate);
float hop_calc_loc_objs(Graph *g, Vertex *client, Vertex *root, 
		       Vertex **servers,
		       int TAPESTRY_NODEID_SIZE, int TAPESTRY_DIGIT_SIZE,
		       int TAPESTRY_NAMESPACE_BASE, int OBJECTS);
int hop_calc_loc_TAP(Graph *g, Vertex *client, Vertex *root, Vertex *server,
		     int TAPESTRY_NODEID_SIZE, int TAPESTRY_DIGIT_SIZE,
		     int TAPESTRY_NAMESPACE_BASE);
int hop_calc_loc_PAT(Graph *g, Vertex *client, Vertex *root, Vertex *server,
		     int TAPESTRY_NODEID_SIZE, int TAPESTRY_DIGIT_SIZE,
		     int TAPESTRY_NAMESPACE_BASE);
void hop_calc_sp(Graph *g, Vertex *sender, Vertex **recvr_array, int n,
		 char *hop_outfile);
void hop_calc_tapestry(Graph *new_graph, Vertex *new_sender,
                Vertex **new_recvr_array, int n,
                char *hop_outfile, int TAPESTRY_NODEID_SIZE,
                int TAPESTRY_DIGIT_SIZE, int TAPESTRY_NAMESPACE_BASE);
void hop_read(long *hop_array, int n, char *hop_outfile);
void rdp_calc(long *hop_array1, long *hop_array2, int n, char *rdp_outfile);

#endif
