#ifndef NODEID_H
#define NODEID_H

/*
#define TAPESTRY_NODEID_SIZE 2                  // 3 digits
#define TAPESTRY_DIGIT_SIZE 4                   // 4 bits in each digit
#define TAPESTRY_NAMESPACE_BASE 16              // hexadecimal digit
#define TAPESTRY_NAMESPACE_SIZE 256             // total of 4096 nodes (16^3)
    
#define TAPESTRY_NODEID_SIZE 3                  // 4 digits
#define TAPESTRY_DIGIT_SIZE 3                   // 3 bits in each digit
#define TAPESTRY_NAMESPACE_BASE 8               // octal digit
#define TAPESTRY_NAMESPACE_SIZE 512             // total of 4096 nodes (8^4)
  
#define TAPESTRY_NODEID_SIZE 4                  // 4 digits
#define TAPESTRY_DIGIT_SIZE 2                   // 2 bits in each digit
#define TAPESTRY_NAMESPACE_BASE 4               // quad digit
#define TAPESTRY_NAMESPACE_SIZE 256             // total of 4096 nodes (4^6)
  
#define TAPESTRY_NODEID_SIZE 8                  // 8 digits
#define TAPESTRY_DIGIT_SIZE 1                   // 1 bit in each digit
#define TAPESTRY_NAMESPACE_BASE 2               // binary digit
#define TAPESTRY_NAMESPACE_SIZE 256             // total of 4096 nodes (2^12)
*/ 

void clear_nodeid_field(Graph *g); 
void clear_picked_t_field(Graph *g);
void tapestry_nodeID_itoa(int id, char *node_id,
                int TAPESTRY_NODEID_SIZE, int TAPESTRY_NAMESPACE_BASE);
void tapestry_nodeID_atoi(char *node_id, int *id,
                int TAPESTRY_NODEID_SIZE, int TAPESTRY_NAMESPACE_BASE);
void assign_tapestry_nodeID(Graph *g, int TAPESTRY_NODEID_SIZE,
                int TAPESTRY_NAMESPACE_BASE, int TAPESTRY_NAMESPACE_SIZE);

#endif
