#ifndef STRESS_H
#define STRESS_H

void clear_stress_field(Graph *g);
void accumulate_physical_link_stress(Graph *g, Vertex *v1, Vertex *v2);
void stress_calc_unicast(Graph *g, Vertex *sender, Vertex **recvr_array,
                        int n, char *stress_outfile);
void stress_calc_tapestry_recurse(Graph *g, Vertex *sender,
        Vertex **recvr_array, int n, int level, int TAPESTRY_NODEID_SIZE,
        int TAPESTRY_DIGIT_SIZE, int TAPESTRY_NAMESPACE_BASE);
void stress_calc_tapestry(Graph *g, Vertex *sender, Vertex **recvr_array,
                int n, char *stress_outfile, int TAPESTRY_NODEID_SIZE,
                int TAPESTRY_DIGIT_SIZE, int TAPESTRY_NAMESPACE_BASE);
#endif
